import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.Vector;

public class Albero {
	
	public static void cancella() {
		radice = null;
	}
	
	public static void azzera(JComponent componento) {
		cancella();
		scriviEtichette = false;
		componente = componento;
		componento.addMouseMotionListener(new MouseMotionAdapter() {
				public void mouseMoved(MouseEvent e) {
					messaggioTool = prendiMessaggio(e.getPoint(),radice);
					componente.setToolTipText(messaggioTool);
				}
			});
	}
	
	public static void setScriviEtichette(boolean scrivi) {
		scriviEtichette = scrivi;
	}
	
	public static void evidenziaNodo(Nodo n) {
		nodoSegnato = n;
	}
	
	public static Nodo getNodoEvidenziato() {
		return nodoSegnato;
	}
	
	private static int maxProfondita(Nodo nodo) {
		if (nodo == null) return -1;
		int max = Math.max(maxProfondita(nodo.left),maxProfondita(nodo.right));
		if (max == -1) return nodo.profondita;
		return max;
	}
	
	private static void disegnaGrafo(Nodo nodo, Graphics g1, Rectangle area) {
		if (nodo == null) return;
		int increm = (int)Math.round(areaTot.height/(0.5+maxProfondita(radice)/*Math.log(nElementi)/Math.log(2)*/));
		disegnaGrafo(nodo.left,g1,new Rectangle(area.x,area.y+increm,area.width/2,area.height-increm));
		disegnaGrafo(nodo.right,g1,new Rectangle(area.x+area.width/2,area.y+increm,area.width/2,area.height-increm));
		Graphics2D g = (Graphics2D)g1;
		float x = area.x + area.width/2 - 5;
		float y = area.y-5;
		nodo.cerchio.setFrame(x,y,10,10);
		Color vecchioColore = g.getColor();
		if (nodo == nodoSegnato) {
			//Color nuovoColore = new Color(vecchioColore.getRed(),vecchioColore.getGreen(),vecchioColore.getBlue()).darker().darker();
			//Color nuovoColore = new Color(255-vecchioColore.getRed(),255-vecchioColore.getGreen(),255-vecchioColore.getBlue());
			Color nuovoColore = new Color(vecchioColore.getRed(),vecchioColore.getGreen(),vecchioColore.getBlue()).darker();
			g.setPaint(nuovoColore);
			Ellipse2D.Double cerchioInterno = new Ellipse2D.Double();
			cerchioInterno.setFrame(nodo.cerchio.getBounds2D());
			g.fill(cerchioInterno);
			g.setPaint(vecchioColore);
		}
		g.draw(nodo.cerchio);

		if (scriviEtichette) {
			float xNome = (float)(nodo.cerchio.x-2-g.getFontMetrics().stringWidth(nodo.etichetta));
			float yNome = (float)(nodo.cerchio.y+nodo.cerchio.height);
			Color coloreNome = new Color(vecchioColore.getRed(),vecchioColore.getGreen(),vecchioColore.getBlue()).darker().darker();
			g.setPaint(coloreNome);
			g.drawString(nodo.etichetta,xNome,yNome);
		}
		
		g.setPaint(vecchioColore);
		if (nodo.left != null)
		g.draw(new Line2D.Double(area.x+area.width/2,y+15,area.x+area.width/4,area.y+increm-10));
		if (nodo.right != null)
		g.draw(new Line2D.Double(area.x+area.width/2,y+15,area.x+area.width/2+area.width/4,area.y+increm-10));
	}
	
	private static void stampa(Nodo nodo) {
		if (nodo == null) return;
		stampa(nodo.left);
		System.out.print(" " + nodo.etichetta + " ");
		stampa(nodo.right);
	}
	
	private static void stampaLivello(Nodo nodo, int livello) {
		if (nodo == null) return;
		if (nodo.profondita == livello) System.out.print(" " + nodo.etichetta + " ");
		stampaLivello(nodo.left,livello);
		stampaLivello(nodo.right,livello);
	}
	
	private static void stampaAlbero() {
		for (int livello=0;livello<10;livello++) {
			stampaLivello(radice,livello);
			System.out.println();
		}
	}
	
	public static void disegnaAlbero(Graphics g, Rectangle area) {
		areaTot = area;
		disegnaGrafo(radice,g,new Rectangle(area.x,area.y+10,area.width,area.height));
	}
	
	
	private static String prendiMessaggio(Point punto, Nodo nodo) {
		if (nodo == null) return null;
		if (nodo.cerchio.contains(punto)) return nodo.etichetta;
		String mess = prendiMessaggio(punto,nodo.left);
		if (mess != null) return mess;
		mess = prendiMessaggio(punto,nodo.right);
		if (mess != null) return mess;
		return null;
	}
	
	public static Nodo aggiungiNodo(String etichetta, int profondita, Nodo nodo) {
		if (radice == null) {
			radice = new Nodo(etichetta,0);
			return radice;
		}
		if (nodo == null) return null;
		if (nodo.profondita > profondita) return null;
		if (nodo.profondita == profondita-1) {
			if (nodo.left == null) {
				nodo.left = new Nodo(etichetta,profondita);
				return nodo.left;
			}
			if (nodo.right == null) {
				nodo.right = new Nodo(etichetta,profondita);
				return nodo.right;
			}
			return null;
		}
		if (nodo.left == null) {
			nodo.left = new Nodo(etichetta,profondita);
			return nodo.left;
		}
		Nodo risultato = aggiungiNodo(etichetta,profondita,nodo.left);
		if (risultato == null) {
			if (nodo.right == null) {
				nodo.right = new Nodo(etichetta,profondita);
				return nodo.right;
			}
			return aggiungiNodo(etichetta,profondita,nodo.right);
		} else return risultato;
	}
	
	
	public static Nodo radice = null;
	private static boolean scriviEtichette = false;
	private static Nodo nodoSegnato = null;
	private static Rectangle areaTot = null;
	private static JComponent componente = null;
	private static String messaggioTool = null;
}