import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class AlberoFrame extends JFrame {
	
	public AlberoFrame(AlgoritmiAnimati theApp, JCheckBox mostraRicors) {
		super("Albero di ricorsione");
		this.theApp = theApp;
		this.mostraRicorsione = mostraRicors;
		//this.setDefaultCloseOperation(this.DO_NOTHING_ON_CLOSE);
		this.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					setVisible(false);
					mostraRicorsione.setSelected(false);
				}
			});
		pannello = new PannelloGrafo();
		Albero.azzera(pannello);
		timero = new Timer(50,new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					pannello.repaint();
				}
			});
		getContentPane().add(pannello);
		this.setBounds(0,0,300,300);
	}
	
	public void iniziaAggiornamenti() {
		timero.start();
	}
	
	public void fermaAggiornamenti() {
		timero.stop();
	}
	
	private class PannelloGrafo extends JComponent {
		public PannelloGrafo() {
			
		}
		
		public void repaint() { //Lo rifaccio per fare double-buffering... Ma non so quanto bene vada..
			Image image = this.createImage(this.getSize().width, this.getSize().height);
			if (image == null) return;
			Graphics g = image.getGraphics();
			g.setColor(this.getBackground());
			g.fillRect(0,0,this.getSize().width,this.getSize().height);
			g.setColor(this.getForeground());
			paint(g);
			this.getGraphics().drawImage(image,0,0,null);
		}
		
		public void paint(Graphics g1) {
			Graphics2D g = (Graphics2D) g1;
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			if (Albero.radice != null) {
				g.setColor(theApp.getColore());
				Albero.disegnaAlbero(g,this.getBounds());
			}
		}
	}
	
	private PannelloGrafo pannello = null;
	private AlgoritmiAnimati theApp = null;
	private JCheckBox mostraRicorsione = null;
	private Timer timero = null;
}