import javax.swing.*;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.InputStream;
import java.util.Vector;
import java.net.URL;

class AlgoritmiFrame extends JFrame implements Costanti {
	
	public AlgoritmiFrame(String titolo, AlgoritmiAnimati app) {
		//this.setDefaultCloseOperation(this.EXIT_ON_CLOSE);   //<<=in un'applet non e' possibile fare cio'
		this.setTitle(titolo);
		this.theApp = app;
		this.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					if (vettoreFrame != null) {
						vettoreFrame.dispose();
					}
					if (finestraCodice != null) {
						finestraCodice.dispose();
					}
					if (finestraAlbero != null) {
						finestraAlbero.dispose();
					}
					dispose();
					theApp.esci();
				}
			});
		JToolBar toolBar = new JToolBar();
		//toolBar.add(indietroVeloce = new Azione("Indietro veloce","Contrario.gif","Esegui al contrario"));
		toolBar.add(indietro = new Azione("Indietro","Indietro.gif","Un passo indietro"));
		pausa = new Azione("Pausa","Pausa.gif","Sospendi l'esecuzione");
		avanti = new Azione("Avanti","Avanti.gif","Riprendi l'esecuzione");
		toolBar.add(playPausa = new Azione("Pausa","Pausa.gif","Sospendi l'esecuzione"));
		toolBar.add(step = new Azione("Step","Step.gif","Un passo avanti"));
		toolBar.add(stop = new Azione("Stop","Stop.gif","Termina l'esecuzione"));
		toolBar.add(ricomincia = new Azione("Inizia","Play2.gif","Inizia l'esecuzione"));
		toolBar.addSeparator();
		toolBar.add(cambiaColore = new Azione("Colore","Colore.gif","Seleziona un colore per il disegno"));
		toolBar.add(scegliVettore = new Azione("Scegli il vettore","Vettore.gif","Seleziona un vettore particolare o uno random"));
		toolBar.addSeparator();

		resettaPulsanti();

		JPanel pannelloSud = new JPanel();
		getContentPane().add(pannelloSud,BorderLayout.SOUTH);

		pannelloSud.add(toolBar,BorderLayout.SOUTH);
		
		slider = new JSlider(INTERVALLO_MIN,INTERVALLO_MAX,INTERVALLO_DEFAULT);
		slider.setToolTipText("Imposta la velocita' dell'algoritmo (sinistra: max, destra: min)");
		slider.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent e) {
					theApp.setIntervallo(((JSlider)e.getSource()).getValue());
				}
			});
		slider.setPreferredSize(new Dimension(100,slider.getSize().height));
		Box boxinaSlider = new Box(BoxLayout.Y_AXIS);
		boxinaSlider.add(new JLabel("< Max    Min >"));
		boxinaSlider.add(slider);
		toolBar.add(boxinaSlider);
		
		turbo = new JCheckBox("Turbo",/*new ImageIcon("Schiantizzo.gif"),*/theApp.getTurbo());
		turbo.setToolTipText("Imposta il turbo all'algoritmo: va alla velocita' massima");
		turbo.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (((JCheckBox)e.getSource()).isSelected()) {
						pianissimo.setEnabled(false);
						slider.setEnabled(false);
						theApp.setTurbo(true);
					} else {
						pianissimo.setEnabled(true);
						theApp.setTurbo(false);
						slider.setEnabled(true);
					}
				}
			});
		Box boxinaVelocita = new Box(BoxLayout.Y_AXIS);
		boxinaVelocita.add(turbo);
		
		pianissimo = new JCheckBox("Lentissimo",false);
		pianissimo.setToolTipText("Imposta la velocita' minima per l'algoritmo");
		pianissimo.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (((JCheckBox)e.getSource()).isSelected()) {
						turbo.setEnabled(false);
						slider.setEnabled(false);
						theApp.setIntervallo(INTERVALLO_LENTISSIMO);
					} else {
						turbo.setEnabled(true);
						slider.setEnabled(true);
						theApp.setIntervallo(slider.getValue());
					}
				}
			});
		boxinaVelocita.add(pianissimo);
		toolBar.add(boxinaVelocita);
		
		String[] codice = theApp.getModel().getCodice();
		String[] spiegazione = theApp.getModel().getSpiegazione();
		
		mostraSpiegazioni = new JCheckBox("Codice",false);
		mostraSpiegazioni.setToolTipText("Mostra la finestra con il codice dell'algoritmo");
		mostraSpiegazioni.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (((JCheckBox)e.getSource()).isSelected()) {
						Rectangle contorno = finestraCodice.getBounds();
						contorno.x = getBounds().x + getBounds().width;
						if (contorno.x + contorno.width >= getToolkit().getScreenSize().width) {
							contorno.x = getToolkit().getScreenSize().width - contorno.width;
						}
						contorno.y = getBounds().y;
						if (contorno.y + contorno.height >= getToolkit().getScreenSize().height) {
							contorno.y = getToolkit().getScreenSize().height - contorno.height;
						}
						finestraCodice.setBounds(contorno);
						finestraCodice.setVisible(true);
						finestraCodice.iniziaAggiornamenti();
					} else {
						finestraCodice.fermaAggiornamenti();
						finestraCodice.setVisible(false);
					}
				}
			});
		finestraCodice = new CodiceFrame(codice,spiegazione,theApp,mostraSpiegazioni);
		toolBar.addSeparator();
		Box boxinaFinestre = new Box(BoxLayout.Y_AXIS);
		boxinaFinestre.add(mostraSpiegazioni);
		
		
		mostraRicorsione = new JCheckBox("Albero",false);
		mostraRicorsione.setToolTipText("Mostra la finestra con l'albero di ricorsione");
		mostraRicorsione.setEnabled(false);
		mostraRicorsione.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (((JCheckBox)e.getSource()).isSelected()) {
						Rectangle contorno = finestraAlbero.getBounds();
						contorno.x = 0;
						contorno.y = getBounds().y;
						finestraAlbero.setBounds(contorno);
						finestraAlbero.setVisible(true);
						finestraAlbero.iniziaAggiornamenti();
					} else {
						finestraAlbero.fermaAggiornamenti();
						finestraAlbero.setVisible(false);
					}
				}
			});
		finestraAlbero = new AlberoFrame(theApp,mostraRicorsione);
		boxinaFinestre.add(mostraRicorsione);
		toolBar.add(boxinaFinestre);
				

		
		String[] listaAlgoritmi = new String[6];
		listaAlgoritmi[0] = BUBBLE_SORT;
		listaAlgoritmi[1] = MERGE_SORT;
		listaAlgoritmi[2] = QUICK_SORT;
		listaAlgoritmi[3] = INSERTION_SORT;
		listaAlgoritmi[4] = SELECTION_SORT;
		listaAlgoritmi[5] = HEAP_SORT;
		JComboBox algoritmi = new JComboBox(listaAlgoritmi);
		algoritmi.setToolTipText("Seleziona l'algoritmo da eseguire");
		algoritmi.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					//ferma l'esecuzione
					stop.actionPerformed(new ActionEvent(stop,ActionEvent.ACTION_PERFORMED,null));
					String algoritmo = (String)(((JComboBox)e.getSource()).getSelectedItem());
					theApp.getModel().inizializza(algoritmo);
					String[] codice = theApp.getModel().getCodice();
					String[] spiegazione = theApp.getModel().getSpiegazione();
					boolean eraVisibile = false;
					if (finestraCodice != null) {
						if (finestraCodice.isVisible()) {
							eraVisibile = true;
							finestraCodice.setVisible(false);
						}
						finestraCodice.dispose();
					}
					finestraCodice = new CodiceFrame(codice,spiegazione,theApp,mostraSpiegazioni);
					if (eraVisibile) {
						Rectangle contorno = finestraCodice.getBounds();
						contorno.x = getBounds().x + getBounds().width;
						if (contorno.x + contorno.width >= getToolkit().getScreenSize().width) {
							contorno.x = getToolkit().getScreenSize().width - contorno.width;
						}
						contorno.y = getBounds().y;
						if (contorno.y + contorno.height >= getToolkit().getScreenSize().height) {
							contorno.y = getToolkit().getScreenSize().height - contorno.height;
						}
						finestraCodice.setBounds(contorno);
						finestraCodice.setVisible(true);
						finestraCodice.iniziaAggiornamenti();	
					}
					
					
					eraVisibile = false;
					if (finestraAlbero != null) {
						if (finestraAlbero.isVisible()) {
							eraVisibile = true;
							finestraAlbero.setVisible(false);
						}
						finestraAlbero.dispose();
					}
					finestraAlbero = new AlberoFrame(theApp,mostraRicorsione);
					mostraRicorsione.setSelected(false);
					mostraRicorsione.setEnabled(false);
					if (algoritmo == MERGE_SORT || algoritmo == QUICK_SORT) {
						mostraRicorsione.setEnabled(true);
						if (eraVisibile) {
							mostraRicorsione.setSelected(true);
							Rectangle contorno = finestraAlbero.getBounds();
							contorno.x = 0;
							contorno.y = getBounds().y;
							finestraAlbero.setBounds(contorno);
							finestraAlbero.setVisible(true);
							finestraAlbero.iniziaAggiornamenti();
						}
					}
				}
			});
		Box boxinaAlgoritmi = new Box(BoxLayout.Y_AXIS);
		JLabel labelAlgoritmi = new JLabel("Algoritmo");
		labelAlgoritmi.setLabelFor(algoritmi);
		boxinaAlgoritmi.add(labelAlgoritmi);
		boxinaAlgoritmi.add(algoritmi);
		boxinaAlgoritmi.add(Box.createGlue());
		toolBar.add(boxinaAlgoritmi);
	}
	
	public void resettaPulsanti() {
		indietro.setEnabled(false);
		step.setEnabled(false);
		stop.setEnabled(false);
		playPausa.setEnabled(false);
		scegliVettore.setEnabled(true);
	}

	class Azione extends AbstractAction {
		Azione(String nome, String icona, String toolTip) {
			super(nome);
			/*if (new File(icona).exists()) {
				putValue(SMALL_ICON,new ImageIcon(icona));
			}*/
			URL urlo=null;
			try {
				urlo = new URL(theApp.getCodiceBase()+/*"Stop.gif"*/icona);
				//putValue(SMALL_ICON,theApp.getImage(urlo));
				InputStream inputtello = urlo.openStream();
				Vector vettorino = new Vector();
				byte bitto = 0;
				int into = 0;
				while ((into = inputtello.read()) != -1) {
					bitto = (byte)(into);
					vettorino.add(new Byte(bitto));
				}
				Byte[] vettorillo = new Byte[0];
				vettorillo = (Byte[])(vettorino.toArray(vettorillo));
				byte[] vettoro = new byte[vettorillo.length];
				for (int i=0;i<vettorillo.length;i++) {
					vettoro[i] = vettorillo[i].byteValue();
					//System.out.print(Byte.toString(vettoro[i]) + " ");
				}
				//System.out.println();
				ImageIcon iconcina = new ImageIcon(vettoro);
				putValue(SMALL_ICON, iconcina);
			} catch(Exception excezzione){}
			//putValue(SMALL_ICON, new ImageIcon(theApp.getCodeBase()+"Stop.gif"));
			if (toolTip != null) {
				putValue(SHORT_DESCRIPTION,toolTip);
			}
		}
		
		public void actionPerformed(ActionEvent e) {
			String nome = (String)getValue(NAME);
			if (nome == null) return;
			/*if (nome.equals(indietroVeloce.getValue(NAME))) {
				return;
			}*/
			if (nome.equals(indietro.getValue(NAME))) {
				if (ListaStati.indietro() < 0) {  //Scorre i "ricordi" all'indietro
					indietro.setEnabled(false);
				}
				return;
			}
			if (nome.equals(pausa.getValue(NAME))) {
				theApp.getModel().pause();
				playPausa.putValue(NAME,avanti.getValue(NAME));
				playPausa.putValue(SHORT_DESCRIPTION,avanti.getValue(SHORT_DESCRIPTION));
				playPausa.putValue(SMALL_ICON,avanti.getValue(SMALL_ICON));
				step.setEnabled(true);
				if (ListaStati.getStato() != null) {
					indietro.setEnabled(true);
				}
				return;
			}
			if (nome.equals(avanti.getValue(NAME))) {	
				while (ListaStati.avanti() >= 0); //Mi rimetto dove era stato messo in pausa prima di continuare
				theApp.getModel().avanti();
				playPausa.putValue(NAME,pausa.getValue(NAME));
				playPausa.putValue(SHORT_DESCRIPTION,pausa.getValue(SHORT_DESCRIPTION));
				playPausa.putValue(SMALL_ICON,pausa.getValue(SMALL_ICON));
				step.setEnabled(false);
				indietro.setEnabled(false);
				return;
			}
			if (nome.equals(stop.getValue(NAME))) {
				theApp.getModel().stop();
				indietro.setEnabled(false);
				step.setEnabled(false);
				stop.setEnabled(false);
				playPausa.setEnabled(false);
				scegliVettore.setEnabled(true);
				return;
			}
			if (nome.equals(step.getValue(NAME))) {
				if (ListaStati.avanti() < 0) { //Se non sto piu' scorrendo i "ricordi", allora chiamo il vero step
					theApp.getModel().step();
				}
				indietro.setEnabled(true);
				return;
			}
			if (nome.equals(ricomincia.getValue(NAME))) {
				theApp.getModel().start();
				stop.setEnabled(true);
				playPausa.setEnabled(true);
				scegliVettore.setEnabled(false);
				return;
			}
			if (nome.equals(cambiaColore.getValue(NAME))) {
				Color colore = JColorChooser.showDialog(theApp.getFinestra(),"Scegli il nuovo colore",theApp.getColore());
				if (colore != null) {
					theApp.setColore(colore);
					if (theApp.getView() != null) theApp.getView().repaint();
					if (vettoreFrame != null) vettoreFrame.repaint();
					if (finestraCodice != null) finestraCodice.repaint();
					if (finestraAlbero != null) finestraAlbero.repaint();
				}
			}
			if (nome.equals(scegliVettore.getValue(NAME))) {
				//scegli il vettore
				if (vettoreFrame == null) {
					vettoreFrame = new VettoreFrame(theApp);
				}
				vettoreFrame.setBounds(0,getBounds().y,3*getBounds().width/4,3*getBounds().height/4);
				vettoreFrame.setVisible(true);
			}
		}
	}
		
	private AlgoritmiAnimati theApp = null;
	
	private Azione indietroVeloce, indietro, playPausa, pausa, 
				   avanti, stop, step, ricomincia, cambiaColore, scegliVettore;
	private JSlider slider = null;
	private JCheckBox mostraSpiegazioni = null,
					  mostraRicorsione = null,
					  turbo = null,
					  pianissimo = null;
	
	private VettoreFrame vettoreFrame = null;
	
	private CodiceFrame finestraCodice = null;
	
	private AlberoFrame finestraAlbero = null;
}