import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

class AlgoritmiModel extends Observable implements Costanti {
	
	public AlgoritmiModel(AlgoritmiAnimati theApp, String algoritmo) {
		this.theApp = theApp;
		this.algoritmo = algoritmo;
		inizializza(algoritmo);
	}
	
	public void setIntervallo(long intervallo) {
		this.sorting.setIntervallo(intervallo);
		this.timer.setDelay((int)intervallo/10);
	}
	
	public String[] getCodice() {
		return this.sorting.getCodice();
	}
	
	public String[] getSpiegazione() {
		return this.sorting.getSpiegazione();
	}
	
	public int getLineaEvidenziata() {
		return this.sorting.getLineaEvidenziata();
	}
	
	public void setVettore(int[] vettore) {
		sorting.setVettore(vettore);
	}
	
	void draw(Graphics g) {
		sorting.draw(g,theApp.getView().getBounds());
	}
	
	void avanti() {
		sorting.riprendi();
		//timer.start();
	}
	
	void step() {
		sorting.step();
		//timer.start();
	}
	
	void start() {
		inizializza(algoritmo);
		sorting.start();
		timer.start();
	}
	
	void stop() {
		timer.stop();
		sorting.stop();
	}
	
	void pause() {
		sorting.sospendi();
		//ListaStati.fineStato();
		//timer.stop();
	}
	
	public void inizializza(String algoritmo) {
		int[] vettore = theApp.getVettore();
		/*new int[theApp.getNElementi()];
		for (int i=0;i<vettore.length;i++) {
			vettore[i] = vettore.length-i;
		}*/
		this.algoritmo = algoritmo;
		if (algoritmo.equals(BUBBLE_SORT)) {
			sorting = new BubbleSort(vettore,theApp.getIntervallo());
		} else if (algoritmo.equals(MERGE_SORT)) {
			sorting = new MergeSort(vettore,theApp.getIntervallo());
		} else if (algoritmo.equals(INSERTION_SORT)) {
			sorting = new InsertionSort(vettore,theApp.getIntervallo());
		} else if (algoritmo.equals(SELECTION_SORT)) {
			sorting = new SelectionSort(vettore,theApp.getIntervallo());
		} else if (algoritmo.equals(QUICK_SORT)) {
			sorting = new QuickSort(vettore,theApp.getIntervallo());
		} else if (algoritmo.equals(HEAP_SORT)) {
			sorting = new HeapSort(vettore,theApp.getIntervallo());
			Albero.azzera(theApp.getView());
		} else {
			//System.out.println("Dovrai aspettare che lo faccio...");
		}
		ListaStati.resetta();
		ListaStati.setSorting(sorting);
		timer = new javax.swing.Timer((int)(theApp.getIntervallo()/10),new AggiornaListener());
	}

	private class AggiornaListener implements ActionListener {
		public AggiornaListener() {
		}
		
		public void actionPerformed(ActionEvent e) {
			setChanged();
			notifyObservers(sorting.getMessaggio());
			
			if (sorting.getThread() == null) {  //Se il sorting e' finito, aggiorno l'ultima volta e stoppo il timer
				setChanged();
				notifyObservers(sorting.getMessaggio());		
				timer.stop();
				theApp.avvisaTerminato();
			}
		}
	}
	
	private AlgoritmiAnimati theApp = null;
	private Sorting sorting = null;
	private javax.swing.Timer timer = null;
	private String algoritmo = null;
}