import java.awt.*;
import javax.swing.*;

public class BubbleSort extends Sorting {
	
	public BubbleSort(int[] vettore, long intervallo) {
		super(intervallo);
		int nElementi = vettore.length;
		this.vettore = new int[nElementi];
		for (int i=0;i<nElementi;i++) {
			this.vettore[i] = vettore[i];
		}
		String[] codice = {
			"void bubbleSort(int a[], int low, int high) {",
			"    if (low == high)",
			"         return;",
			"    int swapped=1;",
			"    for (int i=low; i<high && swapped==1; i++) {",
			"         swapped=0;",
			"         for (int j=low; j<high-(i+1); j++) {",
			"             if (a[j]>a[j+1]) {",
			"                 swap(j,j+1);",
			"                 swapped=1;",
			"             }",
			"         }",
			"    }",
			"}"
		};
		this.codice = codice;
		String[] spiegazione = {
		  	"Entra in BubbleSort con l'array di input, e gli indici inferiore e superiore",
  			"Se indice inferiore = indice superiore",
  			"Ritorna al chiamante",
  			"Il vettore necessita di essere scorso almeno una volta",
  			"Il ciclo pi esterno che man mano riduce la parte di vettore considerata",
  			"Ogni volta si parte sperando che non serva pi riscorrere l'array",
  			"Il ciclo interno che ordina effettivamente l'array, portando in fondo gli elementi pi grandi",
  			"Controlla se  necessario fare uno scambio",
  			"Scambia gli elementi interessati",
  			"Dato che si  fatto uno scambio, bisogna riscorrere l'array",
  			"",
  			"Continua il ciclo for pi interno",
  			"Continua il ciclo for pi esterno",
  			"Fine del BubbleSort"
  		};
  		this.spiegazione = spiegazione;
  	}
	
	public void draw(Graphics g1, Rectangle area) {
		this.area = area; //Per il BubbleSort l'area di disegno e' tutta quanta
		Graphics2D g = (Graphics2D)g1;
		disegnaVettore(g1,vettore,area,xInizio,yInizio,elementoEvidenziato1,elementoEvidenziato2,animazione);
	}
	
	void bubbleSort(int[] a, int low, int high) {
		
	  setMessaggio("Inizio Bubble Sort dall'indice " + (low+1) + " all'indice " + (high+1));
	  
	  evidenziaLinea(0);
	  
	  evidenziaLinea(1);
	  if (low == high) {
	  		evidenziaLinea(2);
			return;
	  }
	  evidenziaLinea(3);
	  int swapped=1;
	  evidenziaLinea(4);
	  for (int i=low; i<high && swapped==1; i++) {
	  	evidenziaLinea(5);
	  	swapped=0;
	  	
	  	setMessaggio("Lavoro sul vettore fino all'indice " + (high-i));
	  	elementoEvidenziato1 = high-(i+1);
	  	pausa(intervallo);
	  	
	  	evidenziaLinea(6);
	   	for (int j=low; j<high-(i+1); j++) {
	   	
	   		evidenziaLinea(7);
	   		if (this.intervallo != this.INTERVALLO_TURBO) {	
		   		elementoEvidenziato1 = j;
		   		elementoEvidenziato2 = j+1;
	   			setMessaggio(Integer.toString(a[j]) + " > " + a[j+1] + " ? ");
	   			pausa(intervallo);
	   		}
	   		
	     	if (a[j] > a[j+1]) {
	     		if (this.intervallo != this.INTERVALLO_TURBO) {
	     			setMessaggio(messaggio + "Si', allora scambio");
	     			pausa(intervallo);
	     		}
	       	
	       		evidenziaLinea(8);
	       		scambia(a,j,j+1);
	       		//pausa(intervallo);
	       		evidenziaLinea(9);
	       		swapped=1;
	       	evidenziaLinea(10);
	       	} else {
	       		if (this.intervallo != this.INTERVALLO_TURBO) {
	       			setMessaggio(messaggio + "No, procedo");
	       		}
	       	}
	       	if (this.intervallo != this.INTERVALLO_TURBO) {
	       		elementoEvidenziato1 = -1;
	       	} else {
	  			setMessaggio("Lavoro sul vettore fino all'indice " + (high-i));
	       		elementoEvidenziato1 = high-(i+1);
	       	}
	       	elementoEvidenziato2 = -1;
      		pausa(intervallo);
      	 evidenziaLinea(11);
	     }
	   evidenziaLinea(12);
	   }
	   
	  elementoEvidenziato1 = elementoEvidenziato2 = -1;
	  setMessaggio("Ho finito!");
	evidenziaLinea(13);
	}
		
	public void run() {
		try {
			bubbleSort(vettore,0,vettore.length);
		} catch (Exception e) {} //Cosi' se il thread viene stoppato, si ferma subito
		/*System.out.println("Inizio il sorting");
		scambia(vettore,4,5);
		System.out.println("Scambiato 4 e 5");
		pausa(intervallo);
		scambia(vettore,5,6);
		System.out.println("Scambiato 5 e 6");
		pausa(intervallo);
		System.out.println("Finito!");*/
		thread = null; // <== Cosa importante da ricordare!! Cosi' quando termina il sorting, il timer viene stoppato
	}
	
}
