import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class CodiceFrame extends JFrame {
	
	public CodiceFrame(String[] aCodice, String[] aSpiegazioni, AlgoritmiAnimati theApp, JCheckBox mostraCodice) {
		//this.setUndecorated(true); //<<cosi' viene un semplice rettangolo
		//this.setMaximizedBounds(new Rectangle(10,10,100,100));  //<<per farla diventare grande cosi' quando premi il bottone per massimizzare
		
		//this.setDefaultCloseOperation(this.DO_NOTHING_ON_CLOSE);
		this.mostraSpiegazioni = mostraCodice;
		this.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					setVisible(false);
					mostraSpiegazioni.setSelected(false);
				}
			});
		this.setResizable(false);
		this.codice = aCodice;
		this.spiegazioni = aSpiegazioni;
		this.theApp = theApp;
		this.setTitle("Finestra del codice");
		pannelloCodice = new PannelloCodice();
		pannelloCodice.addMouseMotionListener(new MouseMotionAdapter() {
				public void mouseMoved(MouseEvent e) {
					//System.out.println("Cliccato su (" + e.getPoint().x + "," + e.getPoint().y + ")!!");
					int indice = e.getPoint().y / altezzaRiga;
					//System.out.println("Ecco la spiegazione di " + codice[indice] + " : " + spiegazioni[indice]);
					if (indice < spiegazioni.length) {
						pannelloCodice.setToolTipText(spiegazioni[indice]);
					}
				}
			});
				

		this.getContentPane().add(pannelloCodice);
		resetta();
	}
	
	private void resetta() {
		pannelloCodice.setFont(new Font ("TimesRoman", Font.PLAIN, 13));
		FontMetrics metrics = pannelloCodice.getFontMetrics(pannelloCodice.getFont());
		int base = metrics.getAscent();
		altezzaRiga = base + metrics.getDescent();
		int larghezzaMassima = 0;
		for (int i=0;i<codice.length;i++) {
			larghezzaMassima = Math.max (larghezzaMassima, metrics.stringWidth(codice[i]));
		}
		this.pannelloCodice.setPreferredSize(new Dimension(larghezzaMassima,altezzaRiga * codice.length+10));
		this.pack();
		
		timero = new Timer(50,new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					pannelloCodice.repaint();
					timero.setDelay((int)theApp.getIntervallo()/10);
				}
			});
	}
    	
    public void iniziaAggiornamenti() {
    	timero.start();
    }
    
    public void fermaAggiornamenti() {
    	timero.stop();
    }
    	
	public void evidenziaRiga(int riga) {
		if (rigaEvidenziata == riga) { //Evito lo sfarfallio!
			return;
		}
		Graphics2D g = (Graphics2D)pannelloCodice.getGraphics();
		if (rigaEvidenziata != -1) {
			coloraRiga(rigaEvidenziata,getBackground(),getForeground(),g);
		}
		rigaEvidenziata = riga;
		if (rigaEvidenziata != -1) {
			coloraRiga(rigaEvidenziata,theApp.getColore(),coloreInverso(theApp.getColore())/*COLORE_EVIDENZIATORE,COLORE_SCRITTA*/,g);
		}
	}
	
	public void coloraRiga(int riga, Color colore1, Color colore2, Graphics2D g) {
		Color coloreVecchio = g.getColor();
		g.setPaint(colore1);
		int x = 0;
		int y = riga*altezzaRiga;
		g.fill(new Rectangle(x,y+altezzaRiga/2-2,pannelloCodice.getBounds().width-1,3*altezzaRiga/4 +2));
		g.setPaint(colore2);
		g.drawString(codice[riga],x,y+altezzaRiga);
		g.setPaint(coloreVecchio);
	}
	
	private Color coloreInverso(Color colore) {
		return new Color(255-colore.getRed(),255-colore.getGreen(),255-colore.getBlue());
	}
	
	private class PannelloCodice extends JPanel {

		public void paint(Graphics g1) {
			evidenziaRiga(theApp.getModel().getLineaEvidenziata());
			Graphics2D g = (Graphics2D)g1;
			g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
			g.clearRect(0,0,this.getBounds().width,this.getBounds().height);
			int x = 0, y = altezzaRiga;
			g.setPaint(theApp.getColore());
			for (int i=0;i<codice.length;i++) {
				g.drawString(codice[i],x,y);
				y += altezzaRiga;
			}
			if (rigaEvidenziata != -1) {
				coloraRiga(rigaEvidenziata,theApp.getColore(),coloreInverso(theApp.getColore())/*COLORE_EVIDENZIATORE,COLORE_SCRITTA*/,g);
			}
		}
	}		
	
	private String[] codice = null;
	private String[] spiegazioni = null;
	private AlgoritmiAnimati theApp = null;
	private JCheckBox mostraSpiegazioni = null;
	private int rigaEvidenziata = -1;
	private int altezzaRiga = 0;
	private PannelloCodice pannelloCodice = null;
	private Timer timero;
	private final Color COLORE_EVIDENZIATORE 	= Color.RED;
	private final Color COLORE_SCRITTA			= Color.WHITE;
}