import java.awt.*;
import javax.swing.*;

public class InsertionSort extends Sorting {
	
	public InsertionSort(int[] vettore, long intervallo) {
		super(intervallo);
		int nElementi = vettore.length;
		this.vettore = new int[nElementi];
		for (int i=0;i<nElementi;i++) {
			this.vettore[i] = vettore[i];
		}
		
		String[] codice = {
			"void insertionSort(int a[], int low, int high) {",
			"   if (low == high)",
			"       return;",
			"   int dim = high - low + 1;",
			"   for (int j=0; j<dim; j++) {",
			"       int key = a[j];",
			"       int i = j - 1;",
			"       while (i >= 0 && a[i] > key) {",
			"           a[i+1] = a[i];",
			"           i--;",
			"       }",
			"       a[i+1] = key;",
			"   }",
			"}"
		};
		this.codice = codice;
		
		String[] spiegazione = {
			"Entra in InsertionSort con l'array di input, e gli indici inferiore e superiore",
  			"Se indice inferiore = indice superiore",
  			"Ritorna al chiamante",
  			"Calcola la dimensione del vettore",
  			"Scorri con j tutto il vettore,",
  			"Scegliendo ogni volta l'elemento j-esimo come elemento \'chiave\'",
  			"Parti dal j-1 -esimo elemento",
  			"Cerca un elemento che sia <= all'elemento chiave, scorrendo il vettore all'indietro",
  			"Se non lo trovi, copia l'elemento corrente su quello precedentemente scorso (\"sposta\" gli elementi di 1)",
  			"Passa all'elemento successivo",
  			"Continua il ciclo",
  			"A questo punto: 1)Ha trovato l'elemento <= alla chiave, o 2)E' all'inizio del vettore (la chiave e' l'elemento piu' piccolo finora) e quello e' il posto per la chiave",
  			"Continua a scorrere il vettore fino in fondo",
  			"Fine dell\' InsertionSort"
  		};
  		this.spiegazione = spiegazione;
	}
	
	public void draw(Graphics g1, Rectangle area) {
		this.area = area; //Per l' InsertionSort l'area di disegno e' tutta quanta
		Graphics2D g = (Graphics2D)g1;
		disegnaVettore(g1,vettore,area,xInizio,yInizio,elementoEvidenziato1,elementoEvidenziato2,animazione);
	}
	
	private void copiaSopra(int[] vettore, int i, int j) { //Copia l'elemento j-esimo sull'i-esimo

		if (this.intervallo != INTERVALLO_TURBO) {
			
			setMessaggio("Copio " + vettore[j] + " al posto " + (i+1));
			
			elementoEvidenziato1 = i; elementoEvidenziato2 = j;

			animazione = true; //Faccio presente che sto animando e quindi i vettori evidenziati vanno disegnati a parte
				
			double distanzaX = 10;
	
			double larghezza = (area.getWidth() - distanzaX)/vettore.length - distanzaX;
			double altezzaMassima = 10 * area.getHeight()/12;
			double altezzaProp = altezzaMassima / massimo(vettore);		
			
			xi = xInizio + i*(distanzaX + larghezza);  //j e' sempre quello che muovo, i e' quello che sta fermo
			yi = yInizio + altezzaMassima;
			xj = xInizio + j*(distanzaX + larghezza);
			yj = yInizio + altezzaMassima;
			xiIniziale = xi;
			xjIniziale = xj;
			yiIniziale = yi;
			yjIniziale = yj;
			
			while (Math.abs(xi - xj) > larghezza/9) {
				xj += larghezza/10;
				dormi(intervallo/8);
			}
			
			animazione = false;
		
		}
		
		vettore[i] = vettore[j];
		ListaStati.fineStato();
	}

	void insertionSort(int a[], int low, int high) {
		setMessaggio("Inizio Insertion Sort dall'indice " + (low+1) + " all'indice " + (high+1));
		
		evidenziaLinea(0);
		
		evidenziaLinea(1);
		if (low == high) {
			
			evidenziaLinea(2);
			return;
		}
		
		evidenziaLinea(3);
		int dim = high - low + 1;
		
		evidenziaLinea(4);
		for (int j=0; j<dim; j++) {
			
			setMessaggio("La chiave ora e' l'elemento di indice " + (j+1) + ", cioe' " + a[j] + ". Il vettore e' ordinato fino all'indice " + j);
			elementoEvidenziato1 = j; elementoEvidenziato2 = -1;
			evidenziaLinea(5);
			int key = a[j];
			pausa(intervallo);

			
			evidenziaLinea(6);
			int i = j - 1;
			
			if (this.intervallo != this.INTERVALLO_TURBO) {	
				if (i >= 0) {
					setMessaggio("La chiave " + key + " ha trovato qui un posto (" + a[i] + " <= " + key + ", oppure siamo all'inizio del vettore) ?");
				} else {
					setMessaggio("La chiave " + key + " ha trovato qui un posto (siamo all'inizio del vettore) ?");
				}
				evidenziaLinea(7);
				elementoEvidenziato2 = i+1;
				pausa(intervallo);
			}
			while (i >= 0 && a[i] > key) {
				
				if (this.intervallo != this.INTERVALLO_TURBO) {	
					setMessaggio("No, continuo a cercarle un posto e sposto in avanti l'elemento corrente");
					evidenziaLinea(8);
					//a[i+1] = a[i];		
					copiaSopra(a,i+1,i);
					pausa(intervallo);
				} else {
					evidenziaLinea(8);
					a[i+1] = a[i];
				}	
				
				evidenziaLinea(9);
				i--;
				
			evidenziaLinea(10);
				
				if (this.intervallo != this.INTERVALLO_TURBO) {	
					if (i >= 0) {
						setMessaggio("La chiave " + key + " ha trovato qui un posto (" + a[i] + " <= " + key + ", oppure siamo all'inizio del vettore) ?");
					} else {
						setMessaggio("La chiave " + key + " ha trovato qui un posto (siamo all'inizio del vettore) ?");
					}
					evidenziaLinea(7);
					elementoEvidenziato2 = i+1;
					pausa(intervallo);
				}
			}
			
			if (this.intervallo != this.INTERVALLO_TURBO) {	
				evidenziaLinea(11);
				setMessaggio("Si'!! Allora, ho trovato un posto per la chiave " + key + " all'indice " + (i+2));
				a[i+1] = key;
				pausa(intervallo);
			} else {
				a[i+1] = key;
			}
		
		evidenziaLinea(12);
		}
		
		elementoEvidenziato1 = elementoEvidenziato2 = -1;
		setMessaggio("Ho finito!");
		
	evidenziaLinea(13);
	}
	
	public void run() {
		try {
			insertionSort(vettore,0,vettore.length-1);
		} catch (Exception e) {} //Cosi' se il thread viene stoppato, si ferma subito
		thread = null; // <== Cosa importante da ricordare!! Cosi' quando termina il sorting, il timer viene stoppato
	}
}