import java.awt.*;
import javax.swing.*;

public class SelectionSort extends Sorting {
	
	public SelectionSort(int[] vettore, long intervallo) {
		super(intervallo);
		int nElementi = vettore.length;
		this.vettore = new int[nElementi];
		for (int i=0;i<nElementi;i++) {
			this.vettore[i] = vettore[i];
		}
		
		String[] codice = {    
			"void selectionSort(int[] a, int low, int high) {",
			"   if (low == high)",
			"       return;",
			"   for(int i = high; i > low; i--) {",
			"       int l = low;",
			"       for(int j = low + 1; j <= i; j++)",
			"         if(a[j] > a[l])",
			"            l = j;",
			"       swap(l, i);",
			"   }",
			"}"
		};
		this.codice = codice;
		
		String[] spiegazione = {
			"Entra in SelectionSort con l'array di input, e gli indici inferiore e superiore",
  			"Se indice inferiore = indice superiore",
  			"Ritorna al chiamante",
  			"Scorri il vettore dalla fine all'inizio (i e' l'indice dove va messo l'elemento massimo del sottovettore {low,i}",
  			"In l tieni l'indice dell'elemento massimo (per il momento lo poniamo a low)",
  			"Scorri tutti gli elementi tra low e i cercando il massimo",
  			"Se l'elemento j-esimo e' piu' grande dell'l-esimo",
  			"Allora lo considero il nuovo massimo temporaneo, e quindi lo faccio puntare da l",
  			"Una volta che ho il massimo, lo metto all'ultimo posto del sottovettore (quindi alla posizione i)",
  			"Continua il ciclo finche' non e' stato trovato un posto per ogni elemento",
  			"Fine del SelectionSort"
  		};
		this.spiegazione = spiegazione;

    }

   	public void draw(Graphics g1, Rectangle area) {
		this.area = area; //Per il SelectionSort l'area di disegno e' tutta quanta
		Graphics2D g = (Graphics2D)g1;
		disegnaVettore(g1,vettore,area,xInizio,yInizio,elementoEvidenziato1,elementoEvidenziato2,animazione);
	}
	
	void selectionSort(int[] a, int low, int high) {
		setMessaggio("Inizio Selection Sort dall'indice " + (low+1) + " all'indice " + (high+1));
		evidenziaLinea(0);
		
		evidenziaLinea(1);
		if (low == high) {
			evidenziaLinea(2);
			return;
		}
		
		evidenziaLinea(3);
		for(int i = high; i > low; i--) {
			
			elementoEvidenziato2 = i;
			setMessaggio("Considero il vettore fino all'indice " + (i+1));
			pausa(intervallo);
			
			evidenziaLinea(4);
			int l = low;
			
			evidenziaLinea(5);			
			if (this.intervallo != this.INTERVALLO_TURBO) {	
				setMessaggio("Cerco il massimo tra gli indici " + (low+2) + " e " + (i+1));
				elementoEvidenziato2 = low+1;
				elementoEvidenziato1 = l;
				pausa(intervallo);
			}
			for(int j = low + 1; j <= i; j++) {
				
				evidenziaLinea(6);

				if (this.intervallo != this.INTERVALLO_TURBO) {
					setMessaggio(Integer.toString(a[j]) + " > " + a[l] + " ? ");
					elementoEvidenziato2 = j;
					pausa(intervallo);
				}
				if(a[j] > a[l]) {
					evidenziaLinea(7);
					if (this.intervallo != this.INTERVALLO_TURBO) {
						setMessaggio(getMessaggio() + "Si', quindi " + a[j] + " e' il nuovo massimo");
						elementoEvidenziato1 = l;
						pausa(intervallo);
					}
					l = j;
				} else {
					if (this.intervallo != this.INTERVALLO_TURBO) {
						setMessaggio(getMessaggio() + "No, quindi il massimo resta " + a[l]);
						elementoEvidenziato1 = l;
						pausa(intervallo);
					}
				}
			}
			
			evidenziaLinea(8);
			if (this.intervallo != this.INTERVALLO_TURBO) {
				setMessaggio("Ora porto il massimo " + a[l] + " in fondo al sotto vettore");
				pausa(intervallo);
			}
			elementoEvidenziato1 = l;
			elementoEvidenziato2 = i;
			scambia(a,l,i);
			
			elementoEvidenziato2 = i;
			elementoEvidenziato1 = -1;
			
		evidenziaLinea(9);
		}
		
		elementoEvidenziato1 = elementoEvidenziato2 = -1;
		setMessaggio("Ho finito!");
		
	evidenziaLinea(10);
	}
	
	public void run() {
		try {
			selectionSort(vettore,0,vettore.length-1);
		} catch (Exception e) {} //Cosi' se il thread viene stoppato si ferma subito
		thread = null; // <== Cosa importante da ricordare!! Cosi' quando termina il sorting, il timer viene stoppato
	}
}