import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.geom.*;

class Sorting implements Runnable, Costanti {
	public void run() {
		
	}
		
	public void draw(Graphics g, Rectangle area) {
		
	}
	
	public Sorting(long intervallo) {
		this.intervallo = intervallo;
		this.elementoEvidenziato1 = -1;
		this.elementoEvidenziato2 = -1;
	}

	public void setIntervallo(long intervallo) {
		this.intervallo = intervallo;
	}

	public void sospendi() {
		sospeso = true;
	}
	
	public synchronized void riprendi() {
		sospeso = false;
		step = false;  //Non chiedo un solo passo (play)
		notify();
	}
	
	public void start() {
		thread = new Thread(this);
		thread.start();
	}
	
	public synchronized void step() {
		sospeso = false;
		step = true;  //Chiedo un solo passo (step)
		notify();
	}
	
	public synchronized void stop() {
		thread = null;
		notify();
	}
	
	public Thread getThread() {
		return thread;
	}
	
	public String getMessaggio() {
		return this.messaggio;
	}
	
	public void setMessaggio(String messaggio) {
		this.messaggio = messaggio;
	}

	public int[] getVettore() {
		return this.vettore;
	}
	
	public void setVettore(int[] vettore) {
		if (thread != null) return; //Se sono in esecuzione, il vettore non lo cambio!
		this.vettore = vettore;
	}
	
	public int getPrimoEvidenziato() {
		return this.elementoEvidenziato1;
	}
	
	public void setPrimoEvidenziato(int primoEvidenziato) {
		this.elementoEvidenziato1 = primoEvidenziato;
	}
	
	public int getSecondoEvidenziato() {
		return this.elementoEvidenziato2;
	}
	
	public void setSecondoEvidenziato(int secondoEvidenziato) {
		this.elementoEvidenziato2 = secondoEvidenziato;
	}
	
	public int getLineaEvidenziata() {
		return this.lineaEvidenziata;
	}
	
	protected void evidenziaLinea(int riga) {
		this.lineaEvidenziata = riga;
		if (intervallo == INTERVALLO_LENTISSIMO) {
			dormi(100);
		} else if (intervallo != INTERVALLO_TURBO) {
			dormi(50);
		} else {
			dormi(2);
		}
	}
	
	public String[] getCodice() {
		return this.codice;
	}
	
	public String[] getSpiegazione() {
		return this.spiegazione;
	}
	
	protected void pausa(long intervallo) throws ThreadStoppatoException {  //Pausa nell'esecuzione dell'algoritmo (cede l'esecuzione agli altri)
		Thread threadCorrente = Thread.currentThread();
		
		if (thread != threadCorrente) { //Se e' stato chiamato stop(), allora il thread e' stato messo a null, e quindi non deve essere piu' eseguito
			throw new ThreadStoppatoException();  //Faccio terminare di brutto il sorting
		}
		try {
			threadCorrente.sleep(intervallo);

			synchronized(this) {
				while (sospeso && thread == threadCorrente) {
					wait();
				}
			}
		} catch (InterruptedException e) {}
		
		if (step) { //Se ho chiesto un solo passo, mi metto gia' sospeso per il prossimo turno
			sospeso = true;
			step = false;
		}
		
		ListaStati.fineStato(); //ATTENZIONE! Non sarebbe proprio l'ideale cambiare stato ad ogni pausa...
	}
	
	protected void dormi(long intervallo) { //Pausa solo per l'animazione dello scambio (non cede l'esecuzione)
		try {
			Thread.currentThread().sleep(intervallo);
		} catch (InterruptedException e) {}
	}
		
	
	protected int massimo(int[] vettore) {
		if (massimo != -1) return massimo;
		massimo = vettore[0];
		for (int i=1;i<vettore.length;i++) {
			if (vettore[i] > massimo) {
				massimo = vettore[i];
			}
		}
		return massimo;
	}
	
	protected void scambia(int[] vettore, int i, int j) {
		if (j<i) {
			int tmp = i; i = j; j = tmp;
		}
				
		if (this.intervallo != this.INTERVALLO_TURBO) {
	
			setMessaggio("Scambio di posto gli elementi agli indici " + (i+1) + " e " + (j+1));
			
			int elementoVecchio1 = elementoEvidenziato1;
			int elementoVecchio2 = elementoEvidenziato2;
			elementoEvidenziato1 = i; elementoEvidenziato2 = j;
			
			//-------Esegue l'animazione e poi scambia veramente-------
		
			animazione = true; //Faccio presente che sto animando e quindi i vettori evidenziati vanno disegnati a parte
	
			double distanzaX = area.width/50;
	
			double larghezza = (area.getWidth() - distanzaX)/vettore.length - distanzaX;
			double altezzaMassima = 10 * area.getHeight()/12;
			double altezzaProp = altezzaMassima / massimo(vettore);		
			
			xi = xInizio + i*(distanzaX + larghezza);
			yi = area.y + yInizio + altezzaMassima;
			xj = xInizio + j*(distanzaX + larghezza);
			yj = area.y + yInizio + altezzaMassima;
			xiIniziale = xi;
			xjIniziale = xj;
			yiIniziale = yi;
			yjIniziale = yj;
			//colorePrimoEvidenziato = Color.RED;
			//coloreSecondoEvidenziato = Color.YELLOW;
			
			Rectangle2D.Double rettangolo = new Rectangle2D.Double();
			Rectangle2D.Double rettangoloEsterno = new Rectangle2D.Double();
			
			while (Math.abs(yi - yj) < larghezza) {
				yi -= larghezza/20; yj += larghezza/20;
				dormi(intervallo/8);
			}
			while (Math.abs(xi - xiIniziale) < Math.abs(xiIniziale - xjIniziale)) {
				xi += larghezza/10;//(int)(Math.abs(xiIniziale - xjIniziale)/20);
				xj -= larghezza/10;//(int)(Math.abs(xiIniziale - xjIniziale)/20);
				dormi(intervallo/8);
			}
			while (Math.abs(yi - yiIniziale) > 0) {
				yi += larghezza/20; yj -= larghezza/20;
				dormi(intervallo/8);
			}
			
			elementoEvidenziato1 = elementoVecchio1;
			elementoEvidenziato2 = elementoVecchio2;
		}
		
		int tmp = vettore[i];
		vettore[i] = vettore[j];
		vettore[j] = tmp;

		animazione = false;

		ListaStati.fineStato();
	}
	
	protected void disegnaRettangolo(Graphics2D g, int[] vett, int i, Rectangle area,
									 double altezzaProp, double larghezza, double x, double y,
									 int primoEvidenziato, int secondoEvidenziato,
									 Color colorito, boolean scriviNumero) {
		Rectangle2D.Double rettangolo = new Rectangle2D.Double();
		Rectangle2D.Double rettangoloEsterno = new Rectangle2D.Double();

		rettangolo.setRect(x, y - altezzaProp * vett[i], larghezza, altezzaProp * vett[i]);
		rettangoloEsterno.setRect(rettangolo.x,rettangolo.y,rettangolo.width+1,rettangolo.height+1);
		Color colore = colorito;
		Color coloreNumero = new Color(255-colorito.getRed(),255-colorito.getGreen(),255-colorito.getBlue());
		Color coloreScuro = new Color(colorito.getRed(),colorito.getGreen(),colorito.getBlue()).darker().darker();
		g.setPaint(coloreScuro);
		g.fill(rettangoloEsterno);
		g.setPaint(colore);
		g.fill(rettangolo);
		g.setPaint(coloreNumero);
		String numero = Integer.toString(vett[i]);
		g.drawString(numero, (int)(x + larghezza/2 - g.getFontMetrics().stringWidth(numero)/2), (int)(y - 5));
		
		if (i == primoEvidenziato || i == secondoEvidenziato) {
			Point2D.Double centro = new Point2D.Double(x + larghezza/2, y + 12);
			double raggio = larghezza/2;
			Point2D.Double a = new Point2D.Double(centro.x-raggio,area.y+area.getHeight()-1);
			Point2D.Double b = new Point2D.Double(centro.x+raggio,area.y+area.getHeight()-1);
			Point2D.Double c = new Point2D.Double(centro.x,y);
			GeneralPath freccina = new GeneralPath();
			freccina.moveTo((float)a.x,(float)((c.y+a.y)/2));
			freccina.lineTo((float)b.x,(float)((c.y+b.y)/2));
			freccina.lineTo((float)c.x,(float)c.y);
			freccina.closePath();
			if (i == primoEvidenziato) {
				g.setPaint(colorePrimoEvidenziato);
			} else {
				g.setPaint(coloreSecondoEvidenziato);
			}
			g.fill(freccina);
			Rectangle2D.Double contorno = new Rectangle2D.Double(rettangolo.x-2,rettangolo.y-2,rettangolo.width+4,rettangolo.height+4);
			g.draw(contorno);
		}
		if (scriviNumero) {
			g.setPaint(coloreScuro);
			float yNumero = (float)((y+y+(area.getHeight()-y-1))/2 + g.getFontMetrics().getAscent());
			yNumero = (int) ((area.y+area.height-1+y)/2+g.getFontMetrics().getAscent()-1);
			float xNumero = (float)(x + (larghezza - g.getFontMetrics().stringWidth(numero))/2);
			/*if (yNumero >= area.getHeight()) {
				yNumero = (int)area.getHeight()-1;
			}*/
			g.drawString(Integer.toString(i+1), xNumero, yNumero);
		}
	}
	
	protected void disegnaVettore(Graphics graph, int[] vett, Rectangle area, 
								  float xInizio, float yInizio,
								  int primoEvidenziato, int secondoEvidenziato,
								  boolean nonDisegnareEvidenziati) {
		
		Graphics2D g = (Graphics2D)graph;

		double distanzaX = 10;

		double larghezza = (area.getWidth() - distanzaX)/vettore.length - distanzaX;
		double altezzaMassima = 10 * area.getHeight()/12;
		double altezzaProp = altezzaMassima / massimo(vettore);		
		
		double x = xInizio, y = yInizio + altezzaMassima;
						
		for (int i=0;i<vett.length;i++) {
			if (nonDisegnareEvidenziati && (i == primoEvidenziato || i == secondoEvidenziato)) {
				x += distanzaX + larghezza;
				continue;
			}
			Color colore = g.getColor();
			
			disegnaRettangolo(g,vett,i,area,altezzaProp,larghezza,x,y,primoEvidenziato,secondoEvidenziato,colore,true);
			
			if (nonDisegnareEvidenziati) { //Se non devo disegnare gli evidenziati, allora per loro ho le coordinate e i colori apposta
				int primo = primoEvidenziato, secondo = secondoEvidenziato;
				if (primo != -1)
					disegnaRettangolo(g,vett,primo,area,altezzaProp,larghezza,xi,yi,-1,-1,colorePrimoEvidenziato,false);
				if (secondo != -1)
					disegnaRettangolo(g,vett,secondo,area,altezzaProp,larghezza,xj,yj,-1,-1,coloreSecondoEvidenziato,false);
			}
				
			g.setPaint(colore);
			x += distanzaX + larghezza;
		}
	}
	
	protected int[] vettore = null;
	protected Thread thread = null;
	protected boolean sospeso = false;
	protected boolean step = false;
	protected String messaggio = new String(" ");
	protected long intervallo = INTERVALLO_DEFAULT;
	
	protected Rectangle area = new Rectangle();
	protected int massimo = -1; //Per calcolare il massimo del vettore solo la prima volta e su quello basarsi per il disegno! (Nel MergeSort il massimo del vettore puo' cambiare e questo non e' carino)
	protected int elementoEvidenziato1 = -1;
	protected int elementoEvidenziato2 = -1;
	protected boolean animazione = false; //Sempre per l'animazione, tengo a mente che sto animando, e quindi non devo eseguire nulla nel metodo draw

	protected double xi,
					 yi,
					 xj,
					 yj;	   
	protected double xiIniziale, xjIniziale,
					 yiIniziale, yjIniziale;
	protected final Color COLORE_PRIMO_DEFAULT = new Color(0,0,150),
						  COLORE_SECONDO_DEFAULT = new Color(0,150,0);
	protected Color  colorePrimoEvidenziato = COLORE_PRIMO_DEFAULT,
		  			  coloreSecondoEvidenziato = COLORE_SECONDO_DEFAULT;
	float xInizio = 10;
	float yInizio = 10;

	protected int lineaEvidenziata = -1; //Indica la linea che la finestra del codice deve evidenziare
	protected String[] codice = null;   //Il codice dell'algoritmo
	protected String[] spiegazione = null; //La spiegazione di ogni riga
}