import javax.swing.*;
import java.awt.*;
import java.io.File;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.net.URL;
import java.io.InputStream;
import java.util.Vector;

public class VettoreFrame extends JFrame {
	
	public VettoreFrame(AlgoritmiAnimati theApp) {
		super("Costruisci il tuo vettore!");
		this.theApp = theApp;
		this.vettore = theApp.getVettore();
		this.nElementi = vettore.length;
		this.getContentPane().add(pannelloVettore = new PannelloVettore(),BorderLayout.CENTER);		
		
		JToolBar barra = new JToolBar();
		barra.add(nuovoRandom = new Azione("Nuovo Random","Vettore.gif","Crea un nuovo vettore random"));
		barra.add(nuovoRandomUnico = new Azione("Nuovo Random Unico","VettoreUnici.gif","Crea un nuovo vettore random i cui elementi siano tutti diversi"));
		barra.add(nuovoOrdinato = new Azione("Nuovo Ordinato","VettoreOrdinato.gif","Crea un nuovo vettore ordinato"));
		barra.add(nuovoOrdinatoInverso = new Azione("Nuovo Ordinato Inverso","VettoreInverso.gif","Crea un nuovo vettore ordinato all'inverso"));
		barra.addSeparator();
		barra.add(slider = new JSlider(1,16,theApp.getNElementi()));
		barra.addSeparator();
		barra.add(ok = new Azione("Ok","Ok.gif","Accetta il vettore e aggiornalo nella finestra principale"));
		barra.add(annulla = new Azione("Annulla","Annulla.gif","Annulla le modifiche al vettore"));
		slider.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent e) {
					int[] copia = new int[nElementi];
					for (int i=0;i<nElementi;i++) {
						copia[i] = vettore[i];
					}
					nElementi = ((JSlider)e.getSource()).getValue();
					vettore = new int[nElementi];
					for (int i=0;i<nElementi;i++) {
						if (i<copia.length) {
							vettore[i] = copia[i];
						} else {
							vettore[i] = (int)(Math.random()*(nElementi)+1);
						}
					}
					pannelloVettore.repaint();
				}
			});
		slider.setToolTipText("Seleziona il numero di elementi del vettore");
		
		this.getContentPane().add(barra,BorderLayout.SOUTH);

	}
	
	public static int[] vettoreRandom(int dimensione, int min, int max) {
		int[] vettore = new int[dimensione];
		for (int i=0;i<dimensione;i++) {
			vettore[i] = (int) (Math.random()*(Math.abs(max-min)+1)+1);
		}
		return vettore;
	}
	
	public static int[] vettoreRandomUnico(int dimensione, int min, int max) {
		int[] vettore = new int[dimensione];
		for (int i=0;i<dimensione;i++) {
			boolean ok = false;
			while (!ok) {
				vettore[i] = (int)(Math.random()*(Math.abs(max-min)+1)+1);
				ok = true;
				for (int j=0;j<i;j++) {
					if (vettore[j] == vettore[i]) {
						ok = false;
						break;
					}
				}
			}
		}
		return vettore;
	}
	
	public void setVisible(boolean visibile) {
		this.aggiorna();
		super.setVisible(visibile);
	}
	
	private int massimo(int[] vettore) {
		if (vettore == null) return 0;
		//if (massimo != -1) return massimo;
		massimo = vettore[0];
		for (int i=0;i<vettore.length;i++) {
			if (massimo < vettore[i]) {
				massimo = vettore[i];
			}
		}
		return massimo;
	}
	
	private void aggiorna() {
		nElementi = vettore.length;
		if (vettoreDisegno != null) {
			if (vettoreDisegno.length != nElementi) {
				vettoreDisegno = new Rectangle2D.Double[nElementi];
			}
		} else vettoreDisegno = new Rectangle2D.Double[nElementi];
		
		Rectangle area = pannelloVettore.getBounds();
		area.width = area.width - 10;
		distanzaX = area.width/50;
		larghezza = (area.getWidth() - distanzaX)/vettore.length - distanzaX;
		double altezzaMassima = 10 * area.getHeight()/12;
		double altezzaProp = altezzaMassima / massimo(vettore);
		double x = distanzaX;
		double y = yInizio + altezzaMassima;
		
		for (int i=0;i<nElementi;i++) {
			if (indiceEvidenziato1 == i || indiceEvidenziato2 == i) {
				x += distanzaX + larghezza;
				continue;
			}
			if (vettoreDisegno[i] == null) vettoreDisegno[i] = new Rectangle2D.Double();
			vettoreDisegno[i].setRect(x,y-altezzaProp*vettore[i],larghezza,altezzaProp*vettore[i]);
			x += distanzaX + larghezza;
		}
	}
	
	private class PannelloVettore extends JComponent {
		public PannelloVettore() {
			MouseHandler handlero = new MouseHandler();
			this.addMouseListener(handlero);
			this.addMouseMotionListener(handlero);
			this.setToolTipText("Clicca di sinistro per spostare e di destro per cambiare il valore");
		}
		
		public void repaint() { //Lo rifaccio per fare double-buffering... Ma non so quanto bene vada..
			Image image = this.createImage(this.getSize().width, this.getSize().height);
			Graphics g = image.getGraphics();
			g.setColor(this.getBackground());
			g.fillRect(0,0,this.getSize().width,this.getSize().height);
			g.setColor(this.getForeground());
			paint(g);
			this.getGraphics().drawImage(image,0,0,null);
		}
		
		public void paint(Graphics g1) {
			Graphics2D g = (Graphics2D)g1;
			aggiorna();
			colore = theApp.getColore();
			g.setPaint(colore);
			for (int i=0;i<nElementi;i++) {
				if (i == indiceEvidenziato1 || i == indiceEvidenziato2) {
					if (i == indiceEvidenziato1) {
						g.setPaint(Color.RED);
					} else {
						g.setPaint(Color.YELLOW);
					}
					g.fill(vettoreDisegno[i]);
				} else {
					g.fill(vettoreDisegno[i]);
				}
				Color coloreAttuale = g.getColor();
				Color coloreInverso = new Color(255-coloreAttuale.getRed(),255-coloreAttuale.getGreen(),255-coloreAttuale.getBlue());
				g.setPaint(coloreInverso);
				float numeroX = (float)(vettoreDisegno[i].x + (vettoreDisegno[i].width - this.getFontMetrics(getFont()).stringWidth(Integer.toString(vettore[i])))/2);
				float numeroY = (float)(vettoreDisegno[i].y + vettoreDisegno[i].height - 5);
				g.drawString(Integer.toString(vettore[i]),numeroX,numeroY);
				numeroX = (float)(vettoreDisegno[i].x + (vettoreDisegno[i].width - this.getFontMetrics(getFont()).stringWidth(Integer.toString(i+1)))/2);
				numeroY = (float)(vettoreDisegno[i].y + vettoreDisegno[i].height + this.getFontMetrics(getFont()).getAscent());
				g.setPaint(coloreAttuale);
				g.drawString(Integer.toString(i+1),numeroX,numeroY);
				g.setPaint(Color.BLACK);
				g.draw(vettoreDisegno[i]);
				g.setPaint(colore);
			}
			/*Sorting sorting = new Sorting(100);
			sorting.setVettore(theApp.getVettore());
			sorting.disegnaVettore(g,theApp.getVettore(),this.getBounds(),(float)xInizio,(float)yInizio,indiceEvidenziato1,indiceEvidenziato2,false);*/
		}
		
		
		private class MouseHandler extends MouseInputAdapter {
			public void mouseClicked(MouseEvent e) {
				Point punto = e.getPoint();
				if (e.getButton() == MouseEvent.BUTTON3) {
					for (int i=0;i<nElementi;i++) {
						if (vettoreDisegno[i].contains(punto)) {
							String input = JOptionPane.showInputDialog(null,"Dammi il nuovo valore dell'elemento");
							if (input != null) {
								int intero;
								try {
									intero = Integer.parseInt(input);
								} catch (Exception etchu) {
									break;
								}
								vettore[i] = intero;
								repaint();
							}
							break;
						}
					}
				}
			}
			
			public void mousePressed(MouseEvent e) {
				inizio = e.getPoint();
				if (bottone1Giu = (e.getButton() == MouseEvent.BUTTON1)) {
					int i;
					for (i=0;i<nElementi;i++) {
						if (vettoreDisegno[i].contains(inizio)) {
							indiceEvidenziato1 = i;
							break;
						}
					}
					if (i == nElementi) bottone1Giu = false;
				}
			}
			
			public void mouseDragged(MouseEvent e) {
				if (!bottone1Giu) return;
				int i;
				for (i=0;i<nElementi;i++) {
					if (vettoreDisegno[i].contains(e.getPoint())) {
						indiceEvidenziato2 = i;
						break;
					}
				}
				if (i == nElementi) {
					indiceEvidenziato2 = -1;
				}
				repaint();
			}
			
			public void mouseReleased(MouseEvent e) {
				fine = e.getPoint();
				if (bottone1Giu = (e.getButton() == MouseEvent.BUTTON1) && indiceEvidenziato1 != -1 && indiceEvidenziato2 != -1) {
					bottone1Giu = false; //altrimenti lo mette a false da solo
					int tmp = vettore[indiceEvidenziato2];
					vettore[indiceEvidenziato2] = vettore[indiceEvidenziato1];
					vettore[indiceEvidenziato1] = tmp;
					inizio = fine = null;
				}
				indiceEvidenziato1 = indiceEvidenziato2 = -1;
				repaint();
			}
			
			private Point inizio, fine;
			private boolean bottone1Giu = false;
		}

		private Color colore = Color.BLUE;
	}
	
	
	private	class Azione extends AbstractAction {
		Azione(String nome, String icona, String toolTip) {
			super(nome);
			/*if (new File(icona).exists()) {
				putValue(SMALL_ICON,new ImageIcon(icona));
			}*/
			
			URL urlo=null;
			try {
				urlo = new URL(theApp.getCodiceBase()+/*"Stop.gif"*/icona);
			//putValue(SMALL_ICON,theApp.getImage(urlo));
			InputStream inputtello = urlo.openStream();
			Vector vettorino = new Vector();
			byte bitto = 0;
			int into = 0;
			while ((into = inputtello.read()) != -1) {
				bitto = (byte)(into);
				vettorino.add(new Byte(bitto));
			}
			Byte[] vettorillo = new Byte[0];
			vettorillo = (Byte[])(vettorino.toArray(vettorillo));
			byte[] vettoro = new byte[vettorillo.length];
			for (int i=0;i<vettorillo.length;i++) {
				vettoro[i] = vettorillo[i].byteValue();
				//System.out.print(Byte.toString(vettoro[i]) + " ");
			}
			//System.out.println();
			ImageIcon iconcina = new ImageIcon(vettoro);
			putValue(SMALL_ICON, iconcina);
			} catch(Exception excezzione){}
			
			if (toolTip != null) {
				putValue(SHORT_DESCRIPTION,toolTip);
			}
		}
		
		public void actionPerformed(ActionEvent e) {
			String nome = (String)getValue(NAME);
			if (nome == null) return;
			if (nome.equals(ok.getValue(NAME))) {
				theApp.setVettore(vettore);
				theApp.getView().repaint();
				setVisible(false);
				return;
			}
			if (nome.equals(annulla.getValue(NAME))) {
				setVisible(false);
				return;
			}
			if (nome.equals(nuovoRandom.getValue(NAME))) {
				vettore = vettoreRandom(nElementi,1,nElementi);					
				pannelloVettore.repaint();
				return;
			}
			if (nome.equals(nuovoRandomUnico.getValue(NAME))) {
				vettore = vettoreRandomUnico(nElementi,1,nElementi);
				pannelloVettore.repaint();
				return;
			}
			if (nome.equals(nuovoOrdinato.getValue(NAME))) {
				vettore = new int[nElementi];
				for (int i=0;i<nElementi;i++) {
					vettore[i] = i+1;
				}
				pannelloVettore.repaint();
				return;
			}
			if (nome.equals(nuovoOrdinatoInverso.getValue(NAME))) {
				vettore = new int[nElementi];
				for (int i=0;i<nElementi;i++) {
					vettore[i] = nElementi-i;
				}
				pannelloVettore.repaint();
				return;
			}
		}
	}
	
	private AlgoritmiAnimati theApp = null;
	private PannelloVettore pannelloVettore = null;
	private int[] vettore = null;
	private Rectangle2D.Double[] vettoreDisegno = new Rectangle2D.Double[0];
	private int nElementi = 0;
	private int massimo = -1;
	private final double xInizio = 10;
	private final double yInizio = 10;
	private double distanzaX;
	private double larghezza;
	private int indiceEvidenziato1 = -1;
	private int indiceEvidenziato2 = -1;
	private Azione ok, annulla, nuovoRandom, nuovoRandomUnico, nuovoOrdinato, nuovoOrdinatoInverso;
	private JSlider slider = null;
}